//*****************************************************************************************************
//  1. t@C
//		FftOctaveView.cpp
//----------------------------------------------------------------------------------------------------
//  2. @\
//		1/3IN^[u̓Ot̃EBhENX̎
//----------------------------------------------------------------------------------------------------
//  3. l
//----------------------------------------------------------------------------------------------------
//  4. 
//		2007.08.09 S.Aizawa VK쐬
//*****************************************************************************************************

#include "stdafx.h"
#include "MMA_G.h"
#include "FftOctaveDlg.h"
#include "FftOctaveView.h"
#include "Define.h"


// CFftOctaveView

IMPLEMENT_DYNAMIC(CFftOctaveView, CWnd)

//*****************************************************************************************************
//  1. ֐
//		CFftOctaveView::CFftOctaveView
//----------------------------------------------------------------------------------------------------
//  2. @\
//		RXgN^
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
CFftOctaveView::CFftOctaveView()
{
	// oϐ
	m_sizeBitmap = 0;
	m_bDispGraph = FALSE;
	m_nCursorX = 0;
	m_bTrackMouse = FALSE;
	m_penCursor.CreatePen(PS_DOT, 1, COLOR_GRAPH_CURSOR);
}


BEGIN_MESSAGE_MAP(CFftOctaveView, CWnd)
	ON_WM_ERASEBKGND()
	ON_WM_PAINT()
	ON_WM_MOUSEMOVE()
END_MESSAGE_MAP()


//*****************************************************************************************************
//  1. ֐
//		CFftOctaveView::PreSubclassWindow
//----------------------------------------------------------------------------------------------------
//  2. @\
//		TuNX
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CFftOctaveView::PreSubclassWindow()
{
	// 
	Initialize();

	CWnd::PreSubclassWindow();
}

//*****************************************************************************************************
//  1. ֐
//		CFftOctaveView::OnEraseBkgnd
//----------------------------------------------------------------------------------------------------
//  2. @\
//		wi`揈
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CDC			*pDC			[I] foCXReLXgւ̃|C^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		BOOL		TRUE
//*****************************************************************************************************
BOOL CFftOctaveView::OnEraseBkgnd(CDC *pDC)
{
	// Ȃ
	return TRUE;
}

//*****************************************************************************************************
//  1. ֐
//		CFftOctaveView::OnPaint
//----------------------------------------------------------------------------------------------------
//  2. @\
//		yCg
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CFftOctaveView::OnPaint()
{
	CPaintDC dc(this);

	// NCAg̈̃TCY擾
	CRect rect;
	GetClientRect(&rect);

	if (m_bDispGraph) {
		// Ot̃rbg}bvʂɓ]
		CBitmap *pBitmapOrg = m_dcGraph.SelectObject(&m_bmpGraph);
		dc.BitBlt(0, 0, rect.Width(), rect.Height(), &m_dcGraph, 0, 0, SRCCOPY);

		// J[\`
		if (m_nCursorX != 0) {
			CRect &rectScale = m_cFftOctaveDraw.m_rectScale;
			CPen *pPenOrg = dc.SelectObject(&m_penCursor);
			dc.MoveTo(m_nCursorX, rectScale.top);
			dc.LineTo(m_nCursorX, rectScale.bottom);
			dc.SelectObject(pPenOrg);
		}

		m_dcGraph.SelectObject(pBitmapOrg);
	} else {
		// O[œhԂ
		CBrush brush;
		brush.CreateSysColorBrush(COLOR_MENU);
		dc.FillRect(&rect, &brush);
	}
}

//*****************************************************************************************************
//  1. ֐
//		CFftOctaveView::Initialize
//----------------------------------------------------------------------------------------------------
//  2. @\
//		
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CFftOctaveView::Initialize()
{
	// foCXReLXg쐬
	CDC *pDC = GetDC();
	m_dcGraph.CreateCompatibleDC(pDC);
	ReleaseDC(pDC);
}

//*****************************************************************************************************
//  1. ֐
//		CFftOctaveView::DispGraph
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Ot\
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		double		*pDataX				[I] X1/3IN^[uf[^ւ̃|C^
//		double		*pDataY				[I] Y1/3IN^[uf[^ւ̃|C^
//		double		*pDataZ				[I] Z1/3IN^[uf[^ւ̃|C^
//		double		*pDataG				[I] 1/3IN^[uf[^ւ̃|C^
//		double		*pLimit1			[I] ~bgCf[^Pւ̃|C^
//		double		*pLimit2			[I] ~bgCf[^Qւ̃|C^
//		int			nData				[I] f[^
//		double		*pOctaveBandFreq	[I] 1/3IN^[uoh̃ohԂ̎gf[^
//		double		fFreqMin			[I] g̍ŏl
//		double		fFreqMax			[I] g̍ől
//		BOOL		bFreqLog			[I] g̑ΐXP[tO
//		double		fLevelMin			[I] x̍ŏl
//		double		fLevelMax			[I] x̍ől
//		BOOL		bLevelLog			[I] x̑ΐXP[tO
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CFftOctaveView::DispGraph(const double *pDataX, const double *pDataY, const double *pDataZ, const double *pDataG,
		const double *pLimit1, const double *pLimit2,
		int nData, const double *pOctaveBandFreq,
		double fFreqMin, double fFreqMax, BOOL bFreqLog, double fLevelMin, double fLevelMax, BOOL bLevelLog)
{
	if (m_hWnd == NULL)
		return;

	// NCAg̈̑傫ɍ킹ărbg}bv쐬
	CRect rectClinet;
	GetClientRect(&rectClinet);
	CSize sizeView(rectClinet.Width(), rectClinet.Height());
	if (m_sizeBitmap != sizeView) {
		m_sizeBitmap = sizeView;

		CDC *pDC = GetDC();
		m_bmpGraph.DeleteObject();
		m_bmpGraph.CreateCompatibleBitmap(pDC, m_sizeBitmap.cx, m_sizeBitmap.cy);
		ReleaseDC(pDC);
	}

	// foCXReLXgɃrbg}bvݒ
	CBitmap *pBitmapOrg = m_dcGraph.SelectObject(&m_bmpGraph);

	// Ot`
	m_cFftOctaveDraw.DrawGraph(m_dcGraph, rectClinet, pDataX, pDataY, pDataZ, pDataG, pLimit1, pLimit2, nData, pOctaveBandFreq, fFreqMin, fFreqMax, bFreqLog, fLevelMin, fLevelMax, bLevelLog);

	// foCXReLXgrbg}bv
	m_dcGraph.SelectObject(pBitmapOrg);

	// Ot\tOZbg
	m_bDispGraph = TRUE;

	// EBhE̖
	Invalidate(FALSE);

	// EBhEXV
	UpdateWindow();
}

//*****************************************************************************************************
//  1. ֐
//		CFftOctaveView::HideGraph
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Ot
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CFftOctaveView::HideGraph()
{
	// Ot\tOZbg
	m_bDispGraph = FALSE;

	// ʕ`
	Invalidate();
}

//*****************************************************************************************************
//  1. ֐
//		CFftOctaveView::OnMouseMove
//----------------------------------------------------------------------------------------------------
//  2. @\
//		}EXړ
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		UINT		nFlags			[I] Ă鉼zL[
//		CPoint		point			[I] }EX̍W
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CFftOctaveView::OnMouseMove(UINT nFlags, CPoint point)
{
	CFftOctaveDlg *pWnd = (CFftOctaveDlg *)GetParent();

	// }EXJ[\XP[΃J[\ʒuf[^\
	CRect &rectScale = m_cFftOctaveDraw.m_rectScale;
	if (rectScale.PtInRect(point)) {
		if (!m_bTrackMouse) {
			TRACKMOUSEEVENT tme;
			tme.cbSize = sizeof(TRACKMOUSEEVENT);
			tme.dwFlags = TME_LEAVE;
			tme.hwndTrack = m_hWnd;
			::TrackMouseEvent(&tme);

			m_bTrackMouse = TRUE;
		}

		pWnd->DispCursorData((double)(point.x - rectScale.left) / rectScale.Width(), (double)(rectScale.bottom - point.y) / rectScale.Height());
	} else
		pWnd->DispCursorData(0, 0);

	CWnd::OnMouseMove(nFlags, point);
}

//*****************************************************************************************************
//  1. ֐
//		CFftOctaveView::OnMouseLeave
//----------------------------------------------------------------------------------------------------
//  2. @\
//		}EXJ[\EBhEOֈړ
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		WPARAM		wParam			[I] WM_MOUSELEAVEbZ[Wp[^
//		LPARAM		lParam			[I] WM_MOUSELEAVEbZ[Wp[^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		LRESULT		0
//*****************************************************************************************************
LRESULT CFftOctaveView::OnMouseLeave(WPARAM wParam, LPARAM lParam)
{
	CFftOctaveDlg *pWnd = (CFftOctaveDlg *)GetParent();

	// J[\ʒuf[^
	pWnd->DispCursorData(0, 0);
	m_bTrackMouse = FALSE;

	return 0;
}

//*****************************************************************************************************
//  1. ֐
//		CFftOctaveView::DispCursor
//----------------------------------------------------------------------------------------------------
//  2. @\
//		J[\\
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		double		fPosX			[I] 0`1ɐKꂽJ[\̈ʒu
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CFftOctaveView::DispCursor(double fPosX)
{
	int nCursorX = 0;

	// J[\WvZ
	if (fPosX != 0) {
		CRect &rectScale = m_cFftOctaveDraw.m_rectScale;
		nCursorX = rectScale.left + (int)(rectScale.Width() * fPosX + 0.5);
		if (nCursorX < rectScale.left || nCursorX > rectScale.right)
			nCursorX = 0;
	}

	// ړĂĕ\
	if (nCursorX != m_nCursorX) {
		m_nCursorX = nCursorX;
		Invalidate(FALSE);
	}
}
